# The PEP 484 type hints stub file for the krita module.
#
# Generated by SIP 6.6.2


import typing

import PyQt5.sip

from PyQt5 import QtWidgets
from PyQt5 import QtXml
from PyQt5 import QtGui
from PyQt5 import QtCore

# Support for QDate, QDateTime and QTime.
import datetime

# Convenient type aliases.
PYQT_SIGNAL = typing.Union[QtCore.pyqtSignal, QtCore.pyqtBoundSignal]
PYQT_SLOT = typing.Union[typing.Callable[..., None], QtCore.pyqtBoundSignal]

# Convenient aliases for complicated OpenGL types.
PYQT_OPENGL_ARRAY = typing.Union[typing.Sequence[int], typing.Sequence[float],
        PyQt5.sip.Buffer, None]
PYQT_OPENGL_BOUND_ARRAY = typing.Union[typing.Sequence[int],
        typing.Sequence[float], PyQt5.sip.Buffer, int, None]


class Shape(QtCore.QObject):

    def parentShape(self) -> 'Shape': ...
    def isSelected(self) -> bool: ...
    def deselect(self) -> None: ...
    def select(self) -> None: ...
    def toSvg(self, prependStyles: bool = ..., stripTextMode: bool = ...) -> str: ...
    def updateAbsolute(self, box: QtCore.QRectF) -> None: ...
    def update(self) -> None: ...
    def remove(self) -> bool: ...
    def absoluteTransformation(self) -> QtGui.QTransform: ...
    def setTransformation(self, matrix: QtGui.QTransform) -> None: ...
    def transformation(self) -> QtGui.QTransform: ...
    def setPosition(self, point: typing.Union[QtCore.QPointF, QtCore.QPoint]) -> None: ...
    def position(self) -> QtCore.QPointF: ...
    def boundingBox(self) -> QtCore.QRectF: ...
    def setGeometryProtected(self, protect: bool) -> None: ...
    def geometryProtected(self) -> bool: ...
    def setSelectable(self, selectable: bool) -> None: ...
    def selectable(self) -> bool: ...
    def setVisible(self, visible: bool) -> None: ...
    def visible(self) -> bool: ...
    def setZIndex(self, zindex: int) -> None: ...
    def zIndex(self) -> int: ...
    def setName(self, name: str) -> None: ...
    def name(self) -> str: ...
    def type(self) -> str: ...


class GroupShape(Shape):

    def children(self) -> typing.List[Shape]: ...


class Canvas(QtCore.QObject):

    def view(self) -> 'View': ...
    def levelOfDetailMode(self) -> bool: ...
    def setLevelOfDetailMode(self, enable: bool) -> None: ...
    def wrapAroundMode(self) -> bool: ...
    def setWrapAroundMode(self, enable: bool) -> None: ...
    def setMirror(self, value: bool) -> None: ...
    def mirror(self) -> bool: ...
    def setRotation(self, angle: float) -> None: ...
    def rotation(self) -> float: ...
    def resetRotation(self) -> None: ...
    def resetZoom(self) -> None: ...
    def setZoomLevel(self, value: float) -> None: ...
    def zoomLevel(self) -> float: ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class Channel(QtCore.QObject):

    def setPixelData(self, value: typing.Union[QtCore.QByteArray, bytes, bytearray], rect: QtCore.QRect) -> None: ...
    def pixelData(self, rect: QtCore.QRect) -> QtCore.QByteArray: ...
    def bounds(self) -> QtCore.QRect: ...
    def channelSize(self) -> int: ...
    def position(self) -> int: ...
    def name(self) -> str: ...
    def setVisible(self, value: bool) -> None: ...
    def visible(self) -> bool: ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class DockWidgetFactoryBase(PyQt5.sip.wrapper):

    class DockPosition(int):
        DockTornOff = ... # type: DockWidgetFactoryBase.DockPosition
        DockTop = ... # type: DockWidgetFactoryBase.DockPosition
        DockBottom = ... # type: DockWidgetFactoryBase.DockPosition
        DockRight = ... # type: DockWidgetFactoryBase.DockPosition
        DockLeft = ... # type: DockWidgetFactoryBase.DockPosition
        DockMinimized = ... # type: DockWidgetFactoryBase.DockPosition

    @typing.overload
    def __init__(self, _id: str, _dockPosition: 'DockWidgetFactoryBase.DockPosition') -> None: ...
    @typing.overload
    def __init__(self, a0: 'DockWidgetFactoryBase') -> None: ...

    def id(self) -> str: ...
    def createDockWidget(self) -> QtWidgets.QDockWidget: ...


class DockWidget(QtWidgets.QDockWidget):

    def __init__(self) -> None: ...

    def canvasChanged(self, canvas: Canvas) -> None: ...
    def canvas(self) -> Canvas: ...


class Document(QtCore.QObject):

    def setAudioTracks(self, files: typing.Iterable[str]) -> bool: ...
    def audioTracks(self) -> typing.List[str]: ...
    def setAudioLevel(self, level: float) -> None: ...
    def audioLevel(self) -> float: ...
    def setGuidesConfig(self, guidesConfig: 'GuidesConfig') -> None: ...
    def guidesConfig(self) -> 'GuidesConfig': ...
    def autosave(self) -> bool: ...
    def setAutosave(self, active: bool) -> None: ...
    def removeAnnotation(self, type: str) -> None: ...
    def setAnnotation(self, type: str, description: str, annotation: typing.Union[QtCore.QByteArray, bytes, bytearray]) -> None: ...
    def annotation(self, type: str) -> QtCore.QByteArray: ...
    def annotationDescription(self, type: str) -> str: ...
    def annotationTypes(self) -> typing.List[str]: ...
    def setCurrentTime(self, time: int) -> None: ...
    def currentTime(self) -> int: ...
    def playBackEndTime(self) -> int: ...
    def playBackStartTime(self) -> int: ...
    def setPlayBackRange(self, start: int, stop: int) -> None: ...
    def animationLength(self) -> int: ...
    def fullClipRangeEndTime(self) -> int: ...
    def setFullClipRangeEndTime(self, endTime: int) -> None: ...
    def fullClipRangeStartTime(self) -> int: ...
    def setFullClipRangeStartTime(self, startTime: int) -> None: ...
    def setFramesPerSecond(self, fps: int) -> None: ...
    def framesPerSecond(self) -> int: ...
    def importAnimation(self, files: typing.Iterable[str], firstFrame: int, step: int) -> bool: ...
    def bounds(self) -> QtCore.QRect: ...
    def setModified(self, modified: bool) -> None: ...
    def modified(self) -> bool: ...
    def setGuidesLocked(self, locked: bool) -> None: ...
    def setGuidesVisible(self, visible: bool) -> None: ...
    def setVerticalGuides(self, lines: typing.Iterable[float]) -> None: ...
    def setHorizontalGuides(self, lines: typing.Iterable[float]) -> None: ...
    def refreshProjection(self) -> None: ...
    def tryBarrierLock(self) -> bool: ...
    def waitForDone(self) -> None: ...
    def unlock(self) -> None: ...
    def lock(self) -> None: ...
    def thumbnail(self, w: int, h: int) -> QtGui.QImage: ...
    def projection(self, x: int = ..., y: int = ..., w: int = ..., h: int = ...) -> QtGui.QImage: ...
    def createColorizeMask(self, name: str) -> 'ColorizeMask': ...
    def createTransformMask(self, name: str) -> 'TransformMask': ...
    def createTransparencyMask(self, name: str) -> 'TransparencyMask': ...
    def createSelectionMask(self, name: str) -> 'SelectionMask': ...
    @typing.overload
    def createFilterMask(self, name: str, filter: 'Filter', selection: 'Selection') -> 'FilterMask': ...
    @typing.overload
    def createFilterMask(self, name: str, filter: 'Filter', selection_source: 'Node') -> 'FilterMask': ...
    def createFileLayer(self, name: str, fileName: str, scalingMethod: str, scalingFilter: str = ...) -> 'FileLayer': ...
    def createVectorLayer(self, name: str) -> 'VectorLayer': ...
    def createFillLayer(self, name: str, filterName: str, configuration: 'InfoObject', selection: 'Selection') -> 'FillLayer': ...
    def createFilterLayer(self, name: str, filter: 'Filter', selection: 'Selection') -> 'FilterLayer': ...
    def createCloneLayer(self, name: str, source: 'Node') -> 'CloneLayer': ...
    def createGroupLayer(self, name: str) -> 'GroupLayer': ...
    def createNode(self, name: str, nodeType: str) -> 'Node': ...
    def saveAs(self, filename: str) -> bool: ...
    def save(self) -> bool: ...
    def shearImage(self, angleX: float, angleY: float) -> None: ...
    def rotateImage(self, radians: float) -> None: ...
    def scaleImage(self, w: int, h: int, xres: int, yres: int, strategy: str) -> None: ...
    def resizeImage(self, x: int, y: int, w: int, h: int) -> None: ...
    def flatten(self) -> None: ...
    def exportImage(self, filename: str, exportConfiguration: 'InfoObject') -> bool: ...
    def crop(self, x: int, y: int, w: int, h: int) -> None: ...
    def close(self) -> bool: ...
    def pixelData(self, x: int, y: int, w: int, h: int) -> QtCore.QByteArray: ...
    def setYRes(self, yRes: float) -> None: ...
    def yRes(self) -> float: ...
    def setXRes(self, xRes: float) -> None: ...
    def xRes(self) -> float: ...
    def setYOffset(self, y: int) -> None: ...
    def yOffset(self) -> int: ...
    def setXOffset(self, x: int) -> None: ...
    def xOffset(self) -> int: ...
    def setWidth(self, value: int) -> None: ...
    def width(self) -> int: ...
    def setSelection(self, value: 'Selection') -> None: ...
    def selection(self) -> 'Selection': ...
    def rootNode(self) -> 'Node': ...
    def setResolution(self, value: int) -> None: ...
    def resolution(self) -> int: ...
    def setName(self, value: str) -> None: ...
    def name(self) -> str: ...
    def setHeight(self, value: int) -> None: ...
    def height(self) -> int: ...
    def setFileName(self, value: str) -> None: ...
    def fileName(self) -> str: ...
    def setDocumentInfo(self, document: str) -> None: ...
    def documentInfo(self) -> str: ...
    def setBackgroundColor(self, color: typing.Union[QtGui.QColor, QtCore.Qt.GlobalColor]) -> bool: ...
    def backgroundColor(self) -> QtGui.QColor: ...
    def setColorSpace(self, value: str, colorDepth: str, colorProfile: str) -> bool: ...
    def setColorProfile(self, colorProfile: str) -> bool: ...
    def colorProfile(self) -> str: ...
    def colorModel(self) -> str: ...
    def colorDepth(self) -> str: ...
    def setBatchmode(self, value: bool) -> None: ...
    def batchmode(self) -> bool: ...
    def nodeByUniqueID(self, id: QtCore.QUuid) -> 'Node': ...
    def nodeByName(self, node: str) -> 'Node': ...
    def topLevelNodes(self) -> typing.List['Node']: ...
    def setActiveNode(self, value: 'Node') -> None: ...
    def activeNode(self) -> 'Node': ...
    def clone(self) -> 'Document': ...
    def guidesLocked(self) -> bool: ...
    def guidesVisible(self) -> bool: ...
    def verticalGuides(self) -> typing.List[float]: ...
    def horizontalGuides(self) -> typing.List[float]: ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class Filter(QtCore.QObject):

    def __init__(self) -> None: ...

    def startFilter(self, node: 'Node', x: int, y: int, w: int, h: int) -> bool: ...
    def apply(self, node: 'Node', x: int, y: int, w: int, h: int) -> None: ...
    def setConfiguration(self, value: 'InfoObject') -> None: ...
    def configuration(self) -> 'InfoObject': ...
    def setName(self, a0: str) -> None: ...
    def name(self) -> str: ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class InfoObject(QtCore.QObject):

    def __init__(self, parent: typing.Optional[QtCore.QObject] = ...) -> None: ...

    def property(self, key: str) -> typing.Any: ...
    def setProperty(self, key: str, value: typing.Any) -> None: ...
    def setProperties(self, value: typing.Dict[str, typing.Any]) -> None: ...
    def properties(self) -> typing.Dict[str, typing.Any]: ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class Extension(QtCore.QObject):

    def __init__(self, parent: typing.Optional[QtCore.QObject] = ...) -> None: ...

    def createActions(self, window: 'Window') -> None: ...
    def setup(self) -> None: ...


class View(QtCore.QObject):

    def flakeToImageTransform(self) -> QtGui.QTransform: ...
    def flakeToCanvasTransform(self) -> QtGui.QTransform: ...
    def flakeToDocumentTransform(self) -> QtGui.QTransform: ...
    def selectedNodes(self) -> typing.List['Node']: ...
    def showFloatingMessage(self, message: str, icon: QtGui.QIcon, timeout: int, priority: int) -> None: ...
    def setDisablePressure(self, value: bool) -> None: ...
    def disablePressure(self) -> bool: ...
    def setGlobalAlphaLock(self, value: bool) -> None: ...
    def globalAlphaLock(self) -> bool: ...
    def setEraserMode(self, value: bool) -> None: ...
    def eraserMode(self) -> bool: ...
    def setPatternSize(self, size: float) -> None: ...
    def patternSize(self) -> float: ...
    def setPaintingFlow(self, flow: float) -> None: ...
    def paintingFlow(self) -> float: ...
    def setBrushRotation(self, brushRotation: float) -> None: ...
    def brushRotation(self) -> float: ...
    def setBrushSize(self, brushSize: float) -> None: ...
    def brushSize(self) -> float: ...
    def setPaintingOpacity(self, opacity: float) -> None: ...
    def paintingOpacity(self) -> float: ...
    def setHDRGamma(self, gamma: float) -> None: ...
    def HDRGamma(self) -> float: ...
    def setHDRExposure(self, exposure: float) -> None: ...
    def HDRExposure(self) -> float: ...
    def setCurrentBlendingMode(self, blendingMode: str) -> None: ...
    def currentBlendingMode(self) -> str: ...
    def setCurrentGradient(self, resource: 'Resource') -> None: ...
    def currentGradient(self) -> 'Resource': ...
    def setCurrentPattern(self, resource: 'Resource') -> None: ...
    def currentPattern(self) -> 'Resource': ...
    def setCurrentBrushPreset(self, resource: 'Resource') -> None: ...
    def currentBrushPreset(self) -> 'Resource': ...
    def setBackGroundColor(self, color: 'ManagedColor') -> None: ...
    def backgroundColor(self) -> 'ManagedColor': ...
    def setForeGroundColor(self, color: 'ManagedColor') -> None: ...
    def foregroundColor(self) -> 'ManagedColor': ...
    def activateResource(self, resource: 'Resource') -> None: ...
    def canvas(self) -> Canvas: ...
    def setVisible(self) -> None: ...
    def visible(self) -> bool: ...
    def setDocument(self, document: Document) -> None: ...
    def document(self) -> Document: ...
    def window(self) -> 'Window': ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class Window(QtCore.QObject):

    def activeViewChanged(self) -> None: ...
    def themeChanged(self) -> None: ...
    def windowClosed(self) -> None: ...
    def createAction(self, id: str, text: str = ..., menuLocation: str = ...) -> QtWidgets.QAction: ...
    def close(self) -> None: ...
    def activate(self) -> None: ...
    def activeView(self) -> View: ...
    def showView(self, view: View) -> None: ...
    def addView(self, document: Document) -> View: ...
    def views(self) -> typing.List[View]: ...
    def dockers(self) -> typing.List[QtWidgets.QDockWidget]: ...
    def qwindow(self) -> QtWidgets.QMainWindow: ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class Krita(QtCore.QObject):

    def __init__(self, parent: typing.Optional[QtCore.QObject] = ...) -> None: ...

    @staticmethod
    def getAppDataLocation() -> str: ...
    @staticmethod
    def krita_i18nc(context: str, text: str) -> str: ...
    @staticmethod
    def krita_i18n(text: str) -> str: ...
    @staticmethod
    def fromVariant(v: typing.Any) -> QtCore.QObject: ...
    @staticmethod
    def instance() -> 'Krita': ...
    def readSetting(self, group: str, name: str, defaultValue: str) -> str: ...
    def writeSetting(self, group: str, name: str, value: str) -> None: ...
    def addDockWidgetFactory(self, _factory: DockWidgetFactoryBase) -> None: ...
    def addExtension(self, _extension: Extension) -> None: ...
    def icon(self, iconName: str) -> QtGui.QIcon: ...
    def openWindow(self) -> Window: ...
    def openDocument(self, filename: str) -> Document: ...
    def extensions(self) -> typing.List[Extension]: ...
    def createDocument(self, width: int, height: int, name: str, colorModel: str, colorDepth: str, profile: str, resolution: float) -> Document: ...
    def recentDocuments(self) -> typing.List[str]: ...
    def resources(self, type: str) -> typing.Any: ...
    def windows(self) -> typing.List[Window]: ...
    def activeWindow(self) -> Window: ...
    def views(self) -> typing.List[View]: ...
    def version(self) -> str: ...
    def notifier(self) -> 'Notifier': ...
    def addProfile(self, profilePath: str) -> bool: ...
    def profiles(self, colorModel: str, ColorDepth: str) -> typing.List[str]: ...
    def filterStrategies(self) -> typing.List[str]: ...
    def colorDepths(self, colorModel: str) -> typing.List[str]: ...
    def colorModels(self) -> typing.List[str]: ...
    def filter(self, name: str) -> Filter: ...
    def filters(self) -> typing.List[str]: ...
    def dockers(self) -> typing.List[QtWidgets.QDockWidget]: ...
    def documents(self) -> typing.List[Document]: ...
    def action(self, name: str) -> QtWidgets.QAction: ...
    def actions(self) -> typing.List[QtWidgets.QAction]: ...
    def setBatchmode(self, value: bool) -> None: ...
    def batchmode(self) -> bool: ...
    def setActiveDocument(self, value: Document) -> None: ...
    def activeDocument(self) -> Document: ...


class Node(QtCore.QObject):

    def paintAbility(self) -> str: ...
    def paintPath(self, path: QtGui.QPainterPath, strokeStyle: str = ..., fillStyle: str = ...) -> None: ...
    def paintEllipse(self, rect: QtCore.QRectF, strokeStyle: str = ..., fillStyle: str = ...) -> None: ...
    def paintPolygon(self, points: typing.Iterable[typing.Union[QtCore.QPointF, QtCore.QPoint]], strokeStyle: str = ..., fillStyle: str = ...) -> None: ...
    def paintRectangle(self, rect: QtCore.QRectF, strokeStyle: str = ..., fillStyle: str = ...) -> None: ...
    def paintLine(self, pointOne: QtCore.QPoint, pointTwo: QtCore.QPoint, pressureOne: float = ..., pressureTwo: float = ..., strokeStyle: str = ...) -> None: ...
    def uniqueId(self) -> QtCore.QUuid: ...
    def index(self) -> int: ...
    def setLayerStyleFromAsl(self, asl: str) -> None: ...
    def layerStyleToAsl(self) -> str: ...
    def thumbnail(self, w: int, h: int) -> QtGui.QImage: ...
    def shearNode(self, angleX: float, angleY: float) -> None: ...
    def cropNode(self, x: int, y: int, w: int, h: int) -> None: ...
    def rotateNode(self, radians: float) -> None: ...
    def scaleNode(self, origin: typing.Union[QtCore.QPointF, QtCore.QPoint], width: int, height: int, strategy: str) -> None: ...
    def mergeDown(self) -> 'Node': ...
    def save(self, filename: str, xRes: float, yRes: float, exportConfiguration: InfoObject, exportRect: QtCore.QRect = ...) -> None: ...
    def duplicate(self) -> 'Node': ...
    def remove(self) -> bool: ...
    def position(self) -> QtCore.QPoint: ...
    def move(self, x: int, y: int) -> None: ...
    def bounds(self) -> QtCore.QRect: ...
    def setPixelData(self, value: typing.Union[QtCore.QByteArray, bytes, bytearray], x: int, y: int, w: int, h: int) -> None: ...
    def projectionPixelData(self, x: int, y: int, w: int, h: int) -> QtCore.QByteArray: ...
    def pixelDataAtTime(self, x: int, y: int, w: int, h: int, time: int) -> QtCore.QByteArray: ...
    def pixelData(self, x: int, y: int, w: int, h: int) -> QtCore.QByteArray: ...
    def setVisible(self, value: bool) -> None: ...
    def hasKeyframeAtTime(self, frameNumber: int) -> bool: ...
    def visible(self) -> bool: ...
    def icon(self) -> QtGui.QIcon: ...
    def type(self) -> str: ...
    def parentNode(self) -> 'Node': ...
    def setOpacity(self, value: int) -> None: ...
    def opacity(self) -> int: ...
    def setName(self, value: str) -> None: ...
    def name(self) -> str: ...
    def hasExtents(self) -> bool: ...
    def setLocked(self, value: bool) -> None: ...
    def locked(self) -> bool: ...
    def setInheritAlpha(self, value: bool) -> None: ...
    def inheritAlpha(self) -> bool: ...
    def setColorSpace(self, colorModel: str, colorDepth: str, colorProfile: str) -> bool: ...
    def setColorProfile(self, colorProfile: str) -> bool: ...
    def colorProfile(self) -> str: ...
    def colorModel(self) -> str: ...
    def setColorLabel(self, value: int) -> None: ...
    def colorLabel(self) -> int: ...
    def collapsed(self) -> bool: ...
    def setCollapsed(self, collapsed: bool) -> None: ...
    def enableAnimation(self) -> None: ...
    def animated(self) -> bool: ...
    def colorDepth(self) -> str: ...
    def setChildNodes(self, nodes: typing.Iterable['Node']) -> None: ...
    def removeChildNode(self, child: 'Node') -> bool: ...
    def addChildNode(self, child: 'Node', above: 'Node') -> bool: ...
    def findChildNodes(self, name: str = ..., recursive: bool = ..., partialMatch: bool = ..., type: str = ..., colorLabelIndex: int = ...) -> typing.List['Node']: ...
    def childNodes(self) -> typing.List['Node']: ...
    def channels(self) -> typing.List[Channel]: ...
    def setBlendingMode(self, value: str) -> None: ...
    def blendingMode(self) -> str: ...
    def setAlphaLocked(self, value: bool) -> None: ...
    def alphaLocked(self) -> bool: ...
    def clone(self) -> 'Node': ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class GroupLayer(Node):

    def passThroughMode(self) -> bool: ...
    def setPassThroughMode(self, passthrough: bool) -> None: ...
    def type(self) -> str: ...


class CloneLayer(Node):

    def setSourceNode(self, node: Node) -> None: ...
    def sourceNode(self) -> Node: ...
    def type(self) -> str: ...


class FilterLayer(Node):

    def filter(self) -> Filter: ...
    def setFilter(self, filter: Filter) -> None: ...
    def type(self) -> str: ...


class FileLayer(Node):

    def path(self) -> str: ...
    def scalingFilter(self) -> str: ...
    def scalingMethod(self) -> str: ...
    def resetCache(self) -> None: ...
    def setProperties(self, FileName: str, ScalingMethod: str, scalingFilter: str) -> None: ...
    def type(self) -> str: ...


class FillLayer(Node):

    def filterConfig(self) -> InfoObject: ...
    def generatorName(self) -> str: ...
    def setGenerator(self, filterName: str, filterConfig: InfoObject) -> bool: ...
    def type(self) -> str: ...


class VectorLayer(Node):

    def setAntialiased(self, antialiased: bool) -> None: ...
    def isAntialiased(self) -> bool: ...
    def createGroupShape(self, name: str, shapes: typing.Iterable[Shape]) -> Shape: ...
    def shapesInRect(self, rect: QtCore.QRectF, omitHiddenShapes: bool = ..., containedMode: bool = ...) -> typing.List[Shape]: ...
    def shapeAtPosition(self, point: typing.Union[QtCore.QPointF, QtCore.QPoint]) -> Shape: ...
    def addShapesFromSvg(self, svg: str) -> typing.List[Shape]: ...
    def toSvg(self) -> str: ...
    def shapes(self) -> typing.List[Shape]: ...
    def type(self) -> str: ...


class FilterMask(Node):

    def filter(self) -> Filter: ...
    def setFilter(self, filter: Filter) -> None: ...
    def type(self) -> str: ...


class SelectionMask(Node):

    def setSelection(self, selection: 'Selection') -> None: ...
    def selection(self) -> 'Selection': ...
    def type(self) -> str: ...


class TransparencyMask(Node):

    def setSelection(self, selection: 'Selection') -> None: ...
    def selection(self) -> 'Selection': ...
    def type(self) -> str: ...


class TransformMask(Node):

    def fromXML(self, xml: str) -> bool: ...
    def toXML(self) -> str: ...
    def finalAffineTransform(self) -> QtGui.QTransform: ...
    def type(self) -> str: ...


class ColorizeMask(Node):

    def setEditKeyStrokes(self, enabled: bool) -> None: ...
    def editKeyStrokes(self) -> bool: ...
    def setShowOutput(self, enabled: bool) -> None: ...
    def showOutput(self) -> bool: ...
    def resetCache(self) -> None: ...
    def updateMask(self, force: bool = ...) -> None: ...
    def limitToDeviceBounds(self) -> bool: ...
    def setLimitToDeviceBounds(self, value: bool) -> None: ...
    def cleanUpAmount(self) -> float: ...
    def setCleanUpAmount(self, value: float) -> None: ...
    def edgeDetectionSize(self) -> float: ...
    def setEdgeDetectionSize(self, value: float) -> None: ...
    def useEdgeDetection(self) -> bool: ...
    def setUseEdgeDetection(self, value: bool) -> None: ...
    def setKeyStrokePixelData(self, value: typing.Union[QtCore.QByteArray, bytes, bytearray], color: 'ManagedColor', x: int, y: int, w: int, h: int) -> bool: ...
    def keyStrokePixelData(self, color: 'ManagedColor', x: int, y: int, w: int, h: int) -> QtCore.QByteArray: ...
    def transparencyIndex(self) -> int: ...
    def removeKeyStroke(self, color: 'ManagedColor') -> None: ...
    def initializeKeyStrokeColors(self, colors: typing.Iterable['ManagedColor'], transparentIndex: int = ...) -> None: ...
    def keyStrokesColors(self) -> typing.List['ManagedColor']: ...
    def type(self) -> str: ...


class Notifier(QtCore.QObject):

    def __init__(self, parent: typing.Optional[QtCore.QObject] = ...) -> None: ...

    def configurationChanged(self) -> None: ...
    def windowCreated(self) -> None: ...
    def windowIsBeingCreated(self, window: Window) -> None: ...
    def viewClosed(self, view: View) -> None: ...
    def viewCreated(self, view: View) -> None: ...
    def imageClosed(self, filename: str) -> None: ...
    def imageSaved(self, filename: str) -> None: ...
    def imageCreated(self, image: Document) -> None: ...
    def applicationClosing(self) -> None: ...
    def setActive(self, value: bool) -> None: ...
    def active(self) -> bool: ...


class Resource(QtCore.QObject):

    def setImage(self, image: QtGui.QImage) -> None: ...
    def image(self) -> QtGui.QImage: ...
    def filename(self) -> str: ...
    def setName(self, value: str) -> None: ...
    def name(self) -> str: ...
    def type(self) -> str: ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class Selection(QtCore.QObject):

    def __init__(self, parent: typing.Optional[QtCore.QObject] = ...) -> None: ...

    def setPixelData(self, value: typing.Union[QtCore.QByteArray, bytes, bytearray], x: int, y: int, w: int, h: int) -> None: ...
    def pixelData(self, x: int, y: int, w: int, h: int) -> QtCore.QByteArray: ...
    def symmetricdifference(self, selection: 'Selection') -> None: ...
    def intersect(self, selection: 'Selection') -> None: ...
    def subtract(self, selection: 'Selection') -> None: ...
    def add(self, selection: 'Selection') -> None: ...
    def replace(self, selection: 'Selection') -> None: ...
    def selectAll(self, node: Node, value: int) -> None: ...
    def select(self, x: int, y: int, w: int, h: int, value: int) -> None: ...
    def resize(self, w: int, h: int) -> None: ...
    def invert(self) -> None: ...
    def smooth(self) -> None: ...
    def shrink(self, xRadius: int, yRadius: int, edgeLock: bool) -> None: ...
    def grow(self, xradius: int, yradius: int) -> None: ...
    def feather(self, radius: int) -> None: ...
    def border(self, xRadius: int, yRadius: int) -> None: ...
    def dilate(self) -> None: ...
    def erode(self) -> None: ...
    def paste(self, destination: Node, x: int, y: int) -> None: ...
    def cut(self, node: Node) -> None: ...
    def copy(self, node: Node) -> None: ...
    def contract(self, value: int) -> None: ...
    def clear(self) -> None: ...
    def move(self, x: int, y: int) -> None: ...
    def y(self) -> int: ...
    def x(self) -> int: ...
    def height(self) -> int: ...
    def width(self) -> int: ...
    def duplicate(self) -> 'Selection': ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class Preset(QtCore.QObject):

    def __init__(self, resource: Resource) -> None: ...

    def fromXML(self, xml: str) -> None: ...
    def toXML(self) -> str: ...


class PresetChooser(QtWidgets.QWidget):

    def __init__(self, parent: typing.Optional[QtWidgets.QWidget] = ...) -> None: ...

    def presetClicked(self, resource: Resource) -> None: ...
    def presetSelected(self, resource: Resource) -> None: ...
    def currentPreset(self) -> Resource: ...
    def setCurrentPreset(self, resource: Resource) -> None: ...


class Scratchpad(QtWidgets.QWidget):

    def __init__(self, view: View, defaultColor: typing.Union[QtGui.QColor, QtCore.Qt.GlobalColor], parent: typing.Optional[QtWidgets.QWidget] = ...) -> None: ...

    def viewportChanged(self, rect: QtCore.QRect) -> None: ...
    def contentChanged(self) -> None: ...
    def scaleChanged(self, scale: float) -> None: ...
    def copyScratchpadImageData(self) -> QtGui.QImage: ...
    def fillPattern(self, transform: QtGui.QTransform = ...) -> None: ...
    def fillDocument(self, fullContent: bool = ...) -> None: ...
    def fillLayer(self, fullContent: bool = ...) -> None: ...
    def fillGradient(self, gradientVectorStart: QtCore.QPoint = ..., gradientVectorEnd: QtCore.QPoint = ..., gradientShape: str = ..., gradientRepeat: str = ..., reverseGradient: bool = ..., dither: bool = ...) -> None: ...
    def fillTransparent(self) -> None: ...
    def fillForeground(self) -> None: ...
    def fillBackground(self) -> None: ...
    def fillDefault(self) -> None: ...
    def contentBounds(self) -> QtCore.QRect: ...
    def viewportBounds(self) -> QtCore.QRect: ...
    def panCenter(self) -> None: ...
    def panTo(self, x: int, y: int) -> None: ...
    def scale(self) -> float: ...
    def scaleReset(self) -> None: ...
    def scaleToFit(self) -> None: ...
    def setScale(self, scale: float) -> None: ...
    def loadScratchpadImage(self, image: QtGui.QImage) -> None: ...
    def setFillColor(self, color: typing.Union[QtGui.QColor, QtCore.Qt.GlobalColor]) -> None: ...
    def setMode(self, modeName: str) -> None: ...
    def setCanvasZoomLink(self, value: bool) -> None: ...
    def canvasZoomLink(self) -> bool: ...
    def linkCanvasZoom(self, value: bool) -> None: ...
    def setModeManually(self, value: bool) -> None: ...
    def clear(self) -> None: ...


class Palette(QtCore.QObject):

    def __init__(self, resource: Resource) -> None: ...

    def save(self) -> bool: ...
    def moveGroup(self, groupName: str, groupNameInsertBefore: str) -> None: ...
    def renameGroup(self, oldGroupName: str, newGroupName: str) -> None: ...
    def changeGroupName(self, oldGroupName: str, newGroupName: str) -> None: ...
    def removeEntry(self, index: int, groupName: str) -> None: ...
    def addEntry(self, entry: 'Swatch', groupName: str) -> None: ...
    def entryByIndexFromGroup(self, index: int, groupName: str) -> 'Swatch': ...
    def colorSetEntryFromGroup(self, index: int, groupName: str) -> 'Swatch': ...
    def entryByIndex(self, index: int) -> 'Swatch': ...
    def colorSetEntryByIndex(self, index: int) -> 'Swatch': ...
    def colorsCountTotal(self) -> int: ...
    def removeGroup(self, name: str, keepColors: bool) -> None: ...
    def addGroup(self, name: str) -> None: ...
    def groupNames(self) -> typing.List[str]: ...
    def setComment(self, comment: str) -> None: ...
    def comment(self) -> str: ...
    def setColumnCount(self, columns: int) -> None: ...
    def columnCount(self) -> int: ...
    def numberOfEntries(self) -> int: ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class PaletteView(QtWidgets.QWidget):

    def __init__(self, parent: typing.Optional[QtWidgets.QWidget] = ...) -> None: ...

    def entrySelectedBackGround(self, entry: 'Swatch') -> None: ...
    def entrySelectedForeGround(self, entry: 'Swatch') -> None: ...
    def trySelectClosestColor(self, color: 'ManagedColor') -> None: ...
    def removeSelectedEntryWithDialog(self) -> bool: ...
    def addGroupWithDialog(self) -> bool: ...
    def addEntryWithDialog(self, color: 'ManagedColor') -> bool: ...
    def setPalette(self, palette: Palette) -> None: ...


class ManagedColor(QtCore.QObject):

    def __init__(self, colorModel: str, colorDepth: str, colorProfile: str, parent: typing.Optional[QtCore.QObject] = ...) -> None: ...

    def __ne__(self, other: object): ...
    def toQString(self) -> str: ...
    def fromXML(self, xml: str) -> None: ...
    def toXML(self) -> str: ...
    def setComponents(self, values: typing.Iterable[float]) -> None: ...
    def componentsOrdered(self) -> typing.List[float]: ...
    def components(self) -> typing.List[float]: ...
    def setColorSpace(self, colorModel: str, colorDepth: str, colorProfile: str) -> bool: ...
    def setColorProfile(self, colorProfile: str) -> bool: ...
    def colorProfile(self) -> str: ...
    def colorModel(self) -> str: ...
    def colorDepth(self) -> str: ...
    @staticmethod
    def fromQColor(qcolor: typing.Union[QtGui.QColor, QtCore.Qt.GlobalColor], canvas: typing.Optional[Canvas] = ...) -> 'ManagedColor': ...
    def colorForCanvas(self, canvas: Canvas) -> QtGui.QColor: ...
    def __eq__(self, other: object): ...


class Swatch(PyQt5.sip.wrapper):

    def __init__(self) -> None: ...

    def isValid(self) -> bool: ...
    def setSpotColor(self, spotColor: bool) -> None: ...
    def spotColor(self) -> bool: ...
    def setColor(self, color: ManagedColor) -> None: ...
    def color(self) -> ManagedColor: ...
    def setId(self, id: str) -> None: ...
    def id(self) -> str: ...
    def setName(self, name: str) -> None: ...
    def name(self) -> str: ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class KisCubicCurvePoint(PyQt5.sip.wrapper):

    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def __init__(self, a0: 'KisCubicCurvePoint') -> None: ...
    @typing.overload
    def __init__(self, x: float, y: float, setAsCorner: bool = ...) -> None: ...

    def __ne__(self, other: object): ...
    def setAsCorner(self, newIsSetAsCorner: bool) -> None: ...
    def setPosition(self, newPosition: typing.Union[QtCore.QPointF, QtCore.QPoint]) -> None: ...
    def setY(self, newY: float) -> None: ...
    def setX(self, newX: float) -> None: ...
    def isSetAsCorner(self) -> bool: ...
    def position(self) -> QtCore.QPointF: ...
    def y(self) -> float: ...
    def x(self) -> float: ...
    def __eq__(self, other: object): ...


class KisCubicCurve(PyQt5.sip.wrapper):

    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def __init__(self, points: typing.Iterable[typing.Union[QtCore.QPointF, QtCore.QPoint]]) -> None: ...
    @typing.overload
    def __init__(self, points: typing.Iterable[KisCubicCurvePoint]) -> None: ...
    @typing.overload
    def __init__(self, curveString: str) -> None: ...
    @typing.overload
    def __init__(self, curve: 'KisCubicCurve') -> None: ...

    def fromString(self, a0: str) -> None: ...
    def toString(self) -> str: ...
    def floatTransfer(self, size: int = ...) -> typing.List[float]: ...
    def uint16Transfer(self, size: int = ...) -> typing.List[int]: ...
    @staticmethod
    def interpolateLinear(normalizedValue: float, transfer: typing.Iterable[float]) -> float: ...
    def name(self) -> str: ...
    def setName(self, name: str) -> None: ...
    def isConstant(self, x: float) -> bool: ...
    def isIdentity(self) -> bool: ...
    def removePoint(self, idx: int) -> None: ...
    @typing.overload
    def addPoint(self, point: KisCubicCurvePoint) -> int: ...
    @typing.overload
    def addPoint(self, position: typing.Union[QtCore.QPointF, QtCore.QPoint], setAsCorner: bool) -> int: ...
    @typing.overload
    def addPoint(self, point: typing.Union[QtCore.QPointF, QtCore.QPoint]) -> int: ...
    def setPointAsCorner(self, idx: int, setAsCorner: bool) -> None: ...
    def setPointPosition(self, idx: int, position: typing.Union[QtCore.QPointF, QtCore.QPoint]) -> None: ...
    @typing.overload
    def setPoint(self, idx: int, point: KisCubicCurvePoint) -> None: ...
    @typing.overload
    def setPoint(self, idx: int, position: typing.Union[QtCore.QPointF, QtCore.QPoint], setAsCorner: bool) -> None: ...
    @typing.overload
    def setPoint(self, idx: int, point: typing.Union[QtCore.QPointF, QtCore.QPoint]) -> None: ...
    @typing.overload
    def setPoints(self, points: typing.Iterable[typing.Union[QtCore.QPointF, QtCore.QPoint]]) -> None: ...
    @typing.overload
    def setPoints(self, points: typing.Iterable[KisCubicCurvePoint]) -> None: ...
    def curvePoints(self) -> typing.List[KisCubicCurvePoint]: ...
    def points(self) -> typing.List[QtCore.QPointF]: ...
    def value(self, x: float) -> float: ...


class AngleSelector(QtCore.QObject):

    def __init__(self) -> None: ...

    def angleChanged(self, angle: float) -> None: ...
    def flip(self, orientations: typing.Union[QtCore.Qt.Orientations, QtCore.Qt.Orientation]) -> None: ...
    @typing.overload
    @staticmethod
    def flipAngle(angle: float, orientations: typing.Union[QtCore.Qt.Orientations, QtCore.Qt.Orientation]) -> float: ...
    @typing.overload
    @staticmethod
    def flipAngle(angle: float, minimum: float, maximum: float, a3: typing.Union[QtCore.Qt.Orientations, QtCore.Qt.Orientation]) -> typing.Tuple[float, bool]: ...
    @typing.overload
    @staticmethod
    def closestCoterminalAngleInRange(angle: float, minimum: float, maximum: float) -> typing.Tuple[float, bool]: ...
    @typing.overload
    def closestCoterminalAngleInRange(self, angle: float) -> typing.Tuple[float, bool]: ...
    def useFlatSpinBox(self, newUseFlatSpinBox: bool) -> None: ...
    def setIncreasingDirection(self, newIncreasingDirection: str) -> None: ...
    def setWidgetsHeight(self, newHeight: int) -> None: ...
    def setFlipOptionsMode(self, newMode: str) -> None: ...
    def setWrapping(self, newWrapping: bool) -> None: ...
    def setPrefix(self, newPrefix: str) -> None: ...
    def setRange(self, newMinimum: float, newMaximum: float) -> None: ...
    def setMinimum(self, newMinimum: float) -> None: ...
    def setMaximum(self, newMaximum: float) -> None: ...
    def setDecimals(self, newNumberOfDecimals: int) -> None: ...
    def setResetAngle(self, newResetAngle: float) -> None: ...
    def setSnapAngle(self, newSnapAngle: float) -> None: ...
    def isUsingFlatSpinBox(self) -> bool: ...
    def increasingDirection(self) -> str: ...
    def widgetsHeight(self) -> int: ...
    def flipOptionsMode(self) -> str: ...
    def wrapping(self) -> bool: ...
    def prefix(self) -> str: ...
    def minimum(self) -> float: ...
    def maximum(self) -> float: ...
    def decimals(self) -> int: ...
    def resetAngle(self) -> float: ...
    def snapAngle(self) -> float: ...
    def angle(self) -> float: ...
    def reset(self) -> None: ...
    def setAngle(self, newAngle: float) -> None: ...
    def widget(self) -> QtWidgets.QWidget: ...


class IntParseSpinBox(QtCore.QObject):

    def __init__(self) -> None: ...

    def noMoreParsingError(self) -> None: ...
    def errorWhileParsing(self, expr: str) -> None: ...
    def veryCleanText(self) -> str: ...
    def isLastValid(self) -> bool: ...
    def setValue(self, value: int, overwriteExpression: bool = ...) -> None: ...
    def stepBy(self, steps: int) -> None: ...
    def widget(self) -> QtWidgets.QSpinBox: ...


class DoubleParseSpinBox(QtCore.QObject):

    def __init__(self) -> None: ...

    def noMoreParsingError(self) -> None: ...
    def errorWhileParsing(self, expr: str) -> None: ...
    def veryCleanText(self) -> str: ...
    def isLastValid(self) -> bool: ...
    def setValue(self, value: float, overwriteExpression: bool = ...) -> None: ...
    def stepBy(self, steps: int) -> None: ...
    def widget(self) -> QtWidgets.QDoubleSpinBox: ...


class SliderSpinBox(QtCore.QObject):

    def __init__(self) -> None: ...

    def draggingFinished(self) -> None: ...
    def setSoftMaximum(self, newSoftMaximum: int) -> None: ...
    def setSoftMinimum(self, newSoftMinimum: int) -> None: ...
    def setSoftRange(self, newSoftMinimum: int, newSoftMaximum: int) -> None: ...
    def setFastSliderStep(self, newFastSliderStep: int) -> None: ...
    def setBlockUpdateSignalOnDrag(self, newBlockUpdateSignalOnDrag: bool) -> None: ...
    def setExponentRatio(self, newExponentRatio: float) -> None: ...
    def setMaximum(self, newMaximum: int, computeNewFastSliderStep: bool = ...) -> None: ...
    def setMinimum(self, newMinimum: int, computeNewFastSliderStep: bool = ...) -> None: ...
    def setRange(self, newMinimum: int, newMaximum: int, computeNewFastSliderStep: bool = ...) -> None: ...
    def setValue(self, newValue: int) -> None: ...
    def isDragging(self) -> bool: ...
    def softMaximum(self) -> int: ...
    def softMinimum(self) -> int: ...
    def fastSliderStep(self) -> int: ...
    def widget(self) -> QtWidgets.QWidget: ...


class DoubleSliderSpinBox(QtCore.QObject):

    def __init__(self) -> None: ...

    def draggingFinished(self) -> None: ...
    def setSoftMaximum(self, newSoftMaximum: float) -> None: ...
    def setSoftMinimum(self, newSoftMinimum: float) -> None: ...
    def setSoftRange(self, newSoftMinimum: float, newSoftMaximum: float) -> None: ...
    def setFastSliderStep(self, newFastSliderStep: float) -> None: ...
    def setBlockUpdateSignalOnDrag(self, newBlockUpdateSignalOnDrag: bool) -> None: ...
    def setExponentRatio(self, newExponentRatio: float) -> None: ...
    def setMaximum(self, newMaximum: float, computeNewFastSliderStep: bool = ...) -> None: ...
    def setMinimum(self, newMinimum: float, computeNewFastSliderStep: bool = ...) -> None: ...
    def setRange(self, newMinimum: float, newMaximum: float, newNumberOfDecimals: int = ..., computeNewFastSliderStep: bool = ...) -> None: ...
    def setValue(self, newValue: float) -> None: ...
    def isDragging(self) -> bool: ...
    def softMaximum(self) -> float: ...
    def softMinimum(self) -> float: ...
    def fastSliderStep(self) -> float: ...
    def widget(self) -> QtWidgets.QWidget: ...


class GuidesConfig(QtCore.QObject):

    def __init__(self, parent: typing.Optional[QtCore.QObject] = ...) -> None: ...

    def setSnap(self, value: bool) -> None: ...
    def snap(self) -> bool: ...
    def setLocked(self, value: bool) -> None: ...
    def locked(self) -> bool: ...
    def setVisible(self, value: bool) -> None: ...
    def visible(self) -> bool: ...
    def removeAllGuides(self) -> None: ...
    def toXml(self) -> str: ...
    def fromXml(self, xmlContent: str) -> bool: ...
    def setVerticalGuides(self, lines: typing.Iterable[float]) -> None: ...
    def verticalGuides(self) -> typing.List[float]: ...
    def setHorizontalGuides(self, lines: typing.Iterable[float]) -> None: ...
    def horizontalGuides(self) -> typing.List[float]: ...
    def hasSamePositionAs(self, guideConfig: 'GuidesConfig') -> bool: ...
    def hasGuides(self) -> bool: ...
    def setLineType(self, lineType: str) -> None: ...
    def lineType(self) -> str: ...
    def setColor(self, color: typing.Union[QtGui.QColor, QtCore.Qt.GlobalColor]) -> None: ...
    def color(self) -> QtGui.QColor: ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


class GridConfig(QtCore.QObject):

    def __init__(self, parent: typing.Optional[QtCore.QObject] = ...) -> None: ...

    def toXml(self) -> str: ...
    def fromXml(self, xmlContent: str) -> bool: ...
    def setColorVertical(self, colorVertical: typing.Union[QtGui.QColor, QtCore.Qt.GlobalColor]) -> None: ...
    def colorVertical(self) -> QtGui.QColor: ...
    def setColorSubdivision(self, colorSubdivision: typing.Union[QtGui.QColor, QtCore.Qt.GlobalColor]) -> None: ...
    def colorSubdivision(self) -> QtGui.QColor: ...
    def setColorMain(self, colorMain: typing.Union[QtGui.QColor, QtCore.Qt.GlobalColor]) -> None: ...
    def colorMain(self) -> QtGui.QColor: ...
    def setLineTypeVertical(self, lineType: str) -> None: ...
    def lineTypeVertical(self) -> str: ...
    def setLineTypeSubdivision(self, lineType: str) -> None: ...
    def lineTypeSubdivision(self) -> str: ...
    def setLineTypeMain(self, lineType: str) -> None: ...
    def lineTypeMain(self) -> str: ...
    def setAngleAspectLocked(self, angleAspectLocked: bool) -> None: ...
    def angleAspectLocked(self) -> bool: ...
    def setSpacingAspectLocked(self, spacingAspectLocked: bool) -> None: ...
    def spacingAspectLocked(self) -> bool: ...
    def setOffsetAspectLocked(self, offsetAspectLocked: bool) -> None: ...
    def offsetAspectLocked(self) -> bool: ...
    def setType(self, gridType: str) -> None: ...
    def type(self) -> str: ...
    def setCellSize(self, cellSize: int) -> None: ...
    def cellSize(self) -> int: ...
    def setCellSpacing(self, cellSpacing: int) -> None: ...
    def cellSpacing(self) -> int: ...
    def setAngleRightActive(self, active: bool) -> None: ...
    def angleRightActive(self) -> bool: ...
    def setAngleLeftActive(self, active: bool) -> None: ...
    def angleLeftActive(self) -> bool: ...
    def setAngleRight(self, angleRight: float) -> None: ...
    def angleRight(self) -> float: ...
    def setAngleLeft(self, angleLeft: float) -> None: ...
    def angleLeft(self) -> float: ...
    def setSubdivision(self, subdivision: int) -> None: ...
    def subdivision(self) -> int: ...
    def setSpacingActiveVertical(self, active: bool) -> None: ...
    def spacingActiveVertical(self) -> bool: ...
    def setSpacingActiveHorizontal(self, active: bool) -> None: ...
    def spacingActiveHorizontal(self) -> bool: ...
    def setSpacing(self, spacing: QtCore.QPoint) -> None: ...
    def spacing(self) -> QtCore.QPoint: ...
    def setOffset(self, offset: QtCore.QPoint) -> None: ...
    def offset(self) -> QtCore.QPoint: ...
    def setSnap(self, snap: bool) -> None: ...
    def snap(self) -> bool: ...
    def setVisible(self, visible: bool) -> None: ...
    def visible(self) -> bool: ...
    def __ne__(self, other: object): ...
    def __eq__(self, other: object): ...


from typing import Type


class DockWidgetFactory(DockWidgetFactoryBase):

    def __init__(self, _id: str, _dockPosition: DockWidgetFactoryBase.DockPosition, _klass: Type[DockWidget]): ...


def qDebug(text: str): ...

